<?php
/**
 * Architecture Construction Theme Customizer.
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package architecture_construction
 */

if( ! function_exists( 'architecture_construction_customize_register' ) ):  
/**
 * Add postMessage support for site title and description for the Theme Customizer.F
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function architecture_construction_customize_register( $wp_customize ) {
 require get_parent_theme_file_path('/inc/controls/changeable-icon.php');

    require get_parent_theme_file_path('/inc/controls/sortable-control.php');
    
    //Register the sortable control type.
    $wp_customize->register_control_type( 'Architecture_Construction_Control_Sortable' ); 

    if ( version_compare( get_bloginfo('version'),'4.9', '>=') ) {
        $wp_customize->get_section( 'static_front_page' )->title = __( 'Static Front Page', 'architecture-construction' );
    }
	
    /* Option list of all post */	
    $architecture_construction_options_posts = array();
    $architecture_construction_options_posts_obj = get_posts('posts_per_page=-1');
    $architecture_construction_options_posts[''] = esc_html__( 'Choose Post', 'architecture-construction' );
    foreach ( $architecture_construction_options_posts_obj as $architecture_construction_posts ) {
    	$architecture_construction_options_posts[$architecture_construction_posts->ID] = $architecture_construction_posts->post_title;
    }
    
    /* Option list of all categories */
    $architecture_construction_args = array(
	   'type'                     => 'post',
	   'orderby'                  => 'name',
	   'order'                    => 'ASC',
	   'hide_empty'               => 1,
	   'hierarchical'             => 1,
	   'taxonomy'                 => 'category'
    ); 
    $architecture_construction_option_categories = array();
    $architecture_construction_category_lists = get_categories( $architecture_construction_args );
    $architecture_construction_option_categories[''] = esc_html__( 'Choose Category', 'architecture-construction' );
    foreach( $architecture_construction_category_lists as $architecture_construction_category ){
        $architecture_construction_option_categories[$architecture_construction_category->term_id] = $architecture_construction_category->name;
    }
    
    /** Default Settings */    
    $wp_customize->add_panel( 
        'wp_default_panel',
         array(
            'priority' => 10,
            'capability' => 'edit_theme_options',
            'theme_supports' => '',
            'title' => esc_html__( 'Default Settings', 'architecture-construction' ),
            'description' => esc_html__( 'Default section provided by wordpress customizer.', 'architecture-construction' ),
        ) 
    );
    
    $wp_customize->get_section( 'title_tagline' )->panel                  = 'wp_default_panel';
    $wp_customize->get_section( 'colors' )->panel                         = 'wp_default_panel';
    $wp_customize->get_section( 'header_image' )->panel                   = 'wp_default_panel';
    $wp_customize->get_section( 'background_image' )->panel               = 'wp_default_panel';
    $wp_customize->get_section( 'static_front_page' )->panel              = 'wp_default_panel';
    
    $wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
    
    /** Default Settings Ends */

     /** Site Title control */
    $wp_customize->add_setting( 
        'header_site_title', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_site_title',
        array(
            'label'       => __( 'Show / Hide Site Title', 'architecture-construction' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    /** Tagline control */
    $wp_customize->add_setting( 
        'header_tagline', 
        array(
            'default'           => false,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_tagline',
        array(
            'label'       => __( 'Show / Hide Tagline', 'architecture-construction' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('logo_width', array(
        'sanitize_callback' => 'absint', 
    ));

    // Add a control for logo width
    $wp_customize->add_control('logo_width', array(
        'label' => __('Logo Width', 'architecture-construction'),
        'section' => 'title_tagline',
        'type' => 'number',
        'input_attrs' => array(
            'min' => '50', 
            'max' => '500', 
            'step' => '5', 
    ),
        'default' => '100', 
    ));

    $wp_customize->add_setting( 'architecture_construction_site_title_size', array(
        'default'           => 30, // Default font size in pixels
        'sanitize_callback' => 'absint', // Sanitize the input as a positive integer
    ) );

    // Add control for site title size
    $wp_customize->add_control( 'architecture_construction_site_title_size', array(
        'type'        => 'number',
        'section'     => 'title_tagline', // You can change this section to your preferred section
        'label'       => __( 'Site Title Font Size (px)', 'architecture-construction' ),
        'input_attrs' => array(
            'min'  => 10,
            'max'  => 100,
            'step' => 1,
        ),
    ) );

    /** Responsive Media settings */
    
    $wp_customize->add_section(
        'architecture_construction_responsive_media_section',
        array(
            'title' => esc_html__( 'Responsive Media Settings', 'architecture-construction' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'architecture_construction_general_settings',
        )
    );

    /** Scroll to top Responsive control */
    $wp_customize->add_setting( 
        'architecture_construction_resp_scroll_top', 
        array(
            'default' => 1,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_resp_scroll_top',
        array(
            'label'       => __( 'Show Scroll To Top', 'architecture-construction' ),
            'section'     => 'architecture_construction_responsive_media_section',
            'type'        => 'checkbox',
        )
    );

        /** Scroll to top Responsive control */
    $wp_customize->add_setting( 
        'architecture_construction_resp_loader', 
        array(
            'default' => 0,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_resp_loader',
        array(
            'label'       => __( 'Show Preloader', 'architecture-construction' ),
            'section'     => 'architecture_construction_responsive_media_section',
            'type'        => 'checkbox',
        )
    );

    /** Responsive Media Ends */

    //Global Color
    $wp_customize->add_section(
        'architecture_construction_global_color',
        array(
            'title' => esc_html__( 'Global Color Settings', 'architecture-construction' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'architecture_construction_general_settings',
        )
    );

    $wp_customize->add_setting('architecture_construction_primary_color', array(
        'default'           => '#fac536',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'architecture_construction_primary_color', array(
        'label'    => __('Theme Primary Color', 'architecture-construction'),
        'section'  => 'architecture_construction_global_color',
        'settings' => 'architecture_construction_primary_color',
    ))); 

    /** Post & Pages Settings */
    $wp_customize->add_panel( 
        'architecture_construction_post_settings',
         array(
            'priority' => 40,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Post & Pages Settings', 'architecture-construction' ),
            'description' => esc_html__( 'Customize Post & Pages Settings', 'architecture-construction' ),
        ) 
    );

    /** Post Layouts */
    
    $wp_customize->add_section(
        'architecture_construction_post_layout_section',
        array(
            'title' => esc_html__( 'Post Layout Settings', 'architecture-construction' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'architecture_construction_post_settings',
        )
    );

    $wp_customize->add_setting('architecture_construction_post_layout_setting', array(
        'default'           => 'right-sidebar',
        'sanitize_callback' => 'architecture_construction_sanitize_post_layout',
    ));

    $wp_customize->add_control('architecture_construction_post_layout_setting', array(
        'label'    => __('Post Column Settings', 'architecture-construction'),
        'section'  => 'architecture_construction_post_layout_section',
        'settings' => 'architecture_construction_post_layout_setting',
        'type'     => 'select',
        'choices'  => array(        
            'right-sidebar'   => __('Right Sidebar', 'architecture-construction'),
            'left-sidebar'   => __('Left Sidebar', 'architecture-construction'),
            'one-column'   => __('One Column', 'architecture-construction'),
            'three-column'   => __('Three Columns', 'architecture-construction'),
            'four-column'   => __('Four Columns', 'architecture-construction'),
            'grid-layout'   => __('Grid Layout', 'architecture-construction')
        ),
    ));

    $wp_customize->add_setting('architecture_construction_archive_pagination_alignment',array(
        'default' => 'left-align',
        'sanitize_callback' => 'architecture_construction_sanitize_pagination_alignment'
    ));
    $wp_customize->add_control('architecture_construction_archive_pagination_alignment',array(
        'type' => 'select',
        'label' => __('Pagination Alignment','architecture-construction'),
        'section' => 'architecture_construction_post_layout_section',
        'choices' => array(
            'right-align' => __('Right Alignment','architecture-construction'),
            'center-align' => __('Center Alignment','architecture-construction'),
            'left-align' => __('Left Alignment','architecture-construction'),
        ),
    ) );

     /** Post Layouts Ends */

    /** Post Settings */
    $wp_customize->add_section(
        'architecture_construction_post_settings',
        array(
            'title' => esc_html__( 'Post Settings', 'architecture-construction' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'architecture_construction_post_settings',
        )
    );

    $wp_customize->add_setting( 
        'architecture_construction_post_excerpt_length', 
        array(
            'default'           => '50',
            'sanitize_callback' => 'architecture_construction_sanitize_number_range',
    ) );
    $wp_customize->add_control( 
        'architecture_construction_post_excerpt_length', 
        array(
            'label'       => esc_html__( 'Excerpt Length', 'architecture-construction' ),
            'section'     => 'architecture_construction_post_settings',
            'type'        => 'number',
            'input_attrs' => array( 'min' => 1, 'max' => 200, 'style' => 'width: 100%;' ),
    ) );

    /** Post Heading control */
    $wp_customize->add_setting( 
        'architecture_construction_post_heading_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_post_heading_setting',
        array(
            'label'       => __( 'Show / Hide Post Heading', 'architecture-construction' ),
            'section'     => 'architecture_construction_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Meta control */
    $wp_customize->add_setting( 
        'architecture_construction_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Post Meta', 'architecture-construction' ),
            'section'     => 'architecture_construction_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Image control */
    $wp_customize->add_setting( 
        'architecture_construction_post_image_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_post_image_setting',
        array(
            'label'       => __( 'Show / Hide Post Image', 'architecture-construction' ),
            'section'     => 'architecture_construction_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Content control */
    $wp_customize->add_setting( 
        'architecture_construction_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Post Content', 'architecture-construction' ),
            'section'     => 'architecture_construction_post_settings',
            'type'        => 'checkbox',
        )
    );
    /** Post ReadMore control */
     $wp_customize->add_setting( 'architecture_construction_read_more_setting', array(
        'default'           => true,
        'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
    ) );

    $wp_customize->add_control( 'architecture_construction_read_more_setting', array(
        'type'        => 'checkbox',
        'section'     => 'architecture_construction_post_settings', 
        'label'       => __( 'Display Read More Button', 'architecture-construction' ),
    ) );
    
       $wp_customize->add_setting('architecture_construction_single_post_align',array(
        'default' => 'left-align',
        'sanitize_callback' => 'architecture_construction_sanitize_post_content_align'
    ));
    $wp_customize->add_control('architecture_construction_single_post_align',array(
        'type' => 'select',
        'label' => __('Post Content Alignment','architecture-construction'),
        'section' => 'architecture_construction_post_settings',
        'choices' => array(
            'left-align' => __('Left Alignment','architecture-construction'),
            'right-align' => __('Right Alignment','architecture-construction'),
            'center-align' => __('Center Alignment','architecture-construction'),
        ),
    ) );

    $wp_customize->add_setting('architecture_construction_blog_meta_order', array(
        'default' => array('heading', 'author', 'featured-image', 'content','button'),
        'sanitize_callback' => 'architecture_construction_sanitize_sortable',
    ));
    $wp_customize->add_control(new Architecture_Construction_Control_Sortable($wp_customize, 'architecture_construction_blog_meta_order', array(
        'label' => esc_html__('Post Meta Ordering', 'architecture-construction'),
        'description' => __('Drag & drop post items to rearrange the ordering ( this control will not function by post format )', 'architecture-construction') ,
        'section' => 'architecture_construction_post_settings',
        'choices' => array(
            'heading' => __('heading', 'architecture-construction') ,
            'author' => __('author', 'architecture-construction') ,
            'featured-image' => __('featured-image', 'architecture-construction') ,
            'content' => __('content', 'architecture-construction') ,
            'button' => __('button', 'architecture-construction') ,
        ) ,
    )));

    /** Post Settings Ends */

    /** Single Post Settings */
    $wp_customize->add_section(
        'architecture_construction_single_post_settings',
        array(
            'title' => esc_html__( 'Single Post Settings', 'architecture-construction' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'architecture_construction_post_settings',
        )
    );

    /** Single Post Meta control */
    $wp_customize->add_setting( 
        'architecture_construction_single_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_single_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Meta', 'architecture-construction' ),
            'section'     => 'architecture_construction_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Content control */
    $wp_customize->add_setting( 
        'architecture_construction_single_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_single_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Content', 'architecture-construction' ),
            'section'     => 'architecture_construction_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Settings Ends */

    // Typography Settings Section
    $wp_customize->add_section('architecture_construction_typography_settings', array(
        'title'      => esc_html__('Typography Settings', 'architecture-construction'),
        'priority'   => 30,
        'capability' => 'edit_theme_options',
        'panel' => 'architecture_construction_general_settings',
    ));

    // Array of fonts to choose from
    $font_choices = array(
        ''               => __('Select', 'architecture-construction'),
        'Arial'          => 'Arial, sans-serif',
        'Verdana'        => 'Verdana, sans-serif',
        'Helvetica'      => 'Helvetica, sans-serif',
        'Times New Roman'=> '"Times New Roman", serif',
        'Georgia'        => 'Georgia, serif',
        'Courier New'    => '"Courier New", monospace',
        'Trebuchet MS'   => '"Trebuchet MS", sans-serif',
        'Tahoma'         => 'Tahoma, sans-serif',
        'Palatino'       => '"Palatino Linotype", serif',
        'Garamond'       => 'Garamond, serif',
        'Impact'         => 'Impact, sans-serif',
        'Comic Sans MS'  => '"Comic Sans MS", cursive, sans-serif',
        'Lucida Sans'    => '"Lucida Sans Unicode", sans-serif',
        'Arial Black'    => '"Arial Black", sans-serif',
        'Gill Sans'      => '"Gill Sans", sans-serif',
        'Segoe UI'       => '"Segoe UI", sans-serif',
        'Open Sans'      => '"Open Sans", sans-serif',
        'Roboto'         => 'Roboto, sans-serif',
        'Lato'           => 'Lato, sans-serif',
        'Montserrat'     => 'Montserrat, sans-serif',
        'Libre Baskerville' => 'Libre Baskerville',
    );

    // Heading Font Setting
    $wp_customize->add_setting('architecture_construction_heading_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'architecture_construction_sanitize_choicess',
    ));
    $wp_customize->add_control('architecture_construction_heading_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Heading', 'architecture-construction'),
        'section' => 'architecture_construction_typography_settings',
    ));

    // Body Font Setting
    $wp_customize->add_setting('architecture_construction_body_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'architecture_construction_sanitize_choicess',
    ));
    $wp_customize->add_control('architecture_construction_body_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Body', 'architecture-construction'),
        'section' => 'architecture_construction_typography_settings',
    ));

    /** Typography Settings Section End */

    /** General Settings */
    $wp_customize->add_panel( 
        'architecture_construction_general_settings',
         array(
            'priority' => 40,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'General Settings', 'architecture-construction' ),
            'description' => esc_html__( 'Customize General Settings', 'architecture-construction' ),
        ) 
    );

    /** General Settings */
    $wp_customize->add_section(
        'architecture_construction_general_settings',
        array(
            'title' => esc_html__( 'Loader Settings', 'architecture-construction' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'architecture_construction_general_settings',
        )
    );

    /** Preloader control */
    $wp_customize->add_setting( 
        'architecture_construction_preloader_setting', 
        array(
            'default'           => false,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_preloader_setting',
        array(
            'label'       => __( 'Show / Hide Preloader', 'architecture-construction' ),
            'section'     => 'architecture_construction_general_settings',
            'type'        => 'checkbox',
        )
    );

    /** General Settings Ends */

    /** Header Section Settings */
    $wp_customize->add_section(
        'architecture_construction_header_section_settings',
        array(
            'title' => esc_html__( 'Header Section Settings', 'architecture-construction' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'architecture_construction_home_page_settings',
        )
    );

    /** Header Section control */
    $wp_customize->add_setting( 
        'architecture_construction_header_setting', 
        array(
            'default' => false ,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_header_setting',
        array(
            'label'       => __( 'Show Header', 'architecture-construction' ),
            'section'     => 'architecture_construction_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    /** Header Text */
    $wp_customize->add_setting(
        'architecture_construction_header_line',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architecture_construction_header_line',
        array(
            'label' => esc_html__( 'Add Header Text', 'architecture-construction' ),
            'section' => 'architecture_construction_header_section_settings',
            'type' => 'text',
        )
    );

    /** Email */
    $wp_customize->add_setting(
        'architecture_construction_header_email',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architecture_construction_header_email',
        array(
            'label' => esc_html__( 'Add Email', 'architecture-construction' ),
            'section' => 'architecture_construction_header_section_settings',
            'type' => 'text',
        )
    );

    $wp_customize->add_setting('architecture_construction_email_icon',array(
        'default'   => 'fas fa-envelope',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Architecture_Construction_Changeable_Icon(
        $wp_customize,'architecture_construction_email_icon',array(
        'label' => __('Mail Icon','architecture-construction'),
        'transport' => 'refresh',
        'section'   => 'architecture_construction_header_section_settings',
        'type'      => 'icon'
    )));

    /** Phone */
    $wp_customize->add_setting(
        'architecture_construction_header_phone',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architecture_construction_header_phone',
        array(
            'label' => esc_html__( 'Add Phone', 'architecture-construction' ),
            'section' => 'architecture_construction_header_section_settings',
            'type' => 'text',
        )
    );

    $wp_customize->add_setting('architecture_construction_phone_icon',array(
        'default'   => 'fas fa-phone-alt',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Architecture_Construction_Changeable_Icon(
        $wp_customize,'architecture_construction_phone_icon',array(
        'label' => __('Phone Icon','architecture-construction'),
        'transport' => 'refresh',
        'section'   => 'architecture_construction_header_section_settings',
        'type'      => 'icon'
    )));

    /**  Location */
    $wp_customize->add_setting(
        'architecture_construction_header_location',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architecture_construction_header_location',
        array(
            'label' => esc_html__( 'Add Location', 'architecture-construction' ),
            'section' => 'architecture_construction_header_section_settings',
            'type' => 'text',
        )
    );

    $wp_customize->add_setting('architecture_construction_Location_icon',array(
        'default'   => 'fas fa-map-marker-alt',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Architecture_Construction_Changeable_Icon(
        $wp_customize,'architecture_construction_Location_icon',array(
        'label' => __('Location Icon','architecture-construction'),
        'transport' => 'refresh',
        'section'   => 'architecture_construction_header_section_settings',
        'type'      => 'icon'
    )));

    /** Appointment Button */
    $wp_customize->add_setting(
        'architecture_construction_header_btn_text',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architecture_construction_header_btn_text',
        array(
            'label' => esc_html__( 'Add Button Text', 'architecture-construction' ),
            'section' => 'architecture_construction_header_section_settings',
            'type' => 'text',
        )
    );

    /** Appointment Button */
    $wp_customize->add_setting(
        'architecture_construction_header_btn_url',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architecture_construction_header_btn_url',
        array(
            'label' => esc_html__( 'Add Button URL', 'architecture-construction' ),
            'section' => 'architecture_construction_header_section_settings',
            'type' => 'url',
        )
    );

    /** Sticky Header control */
    $wp_customize->add_setting( 
        'architecture_construction_sticky_header', 
        array(
            'default' => false,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_sticky_header',
        array(
            'label'       => __( 'Show Sticky Header', 'architecture-construction' ),
            'section'     => 'architecture_construction_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Add Setting for Menu Font Weight
    $wp_customize->add_setting( 'menu_font_weight', array(
        'default'           => '500',
        'sanitize_callback' => 'architecture_construction_sanitize_font_weight',
    ) );

    // Add Control for Menu Font Weight
    $wp_customize->add_control( 'menu_font_weight', array(
        'label'    => __( 'Menu Font Weight', 'architecture-construction' ),
        'section'  => 'architecture_construction_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            '100' => __( '100 - Thin', 'architecture-construction' ),
            '200' => __( '200 - Extra Light', 'architecture-construction' ),
            '300' => __( '300 - Light', 'architecture-construction' ),
            '400' => __( '400 - Normal', 'architecture-construction' ),
            '500' => __( '500 - Medium', 'architecture-construction' ),
            '600' => __( '600 - Semi Bold', 'architecture-construction' ),
            '700' => __( '700 - Bold', 'architecture-construction' ),
            '800' => __( '800 - Extra Bold', 'architecture-construction' ),
            '900' => __( '900 - Black', 'architecture-construction' ),
        ),
    ) );

    // Add Setting for Menu Text Transform
    $wp_customize->add_setting( 'menu_text_transform', array(
        'default'           => 'capitalize',
        'sanitize_callback' => 'architecture_construction_sanitize_text_transform',
    ) );

    // Add Control for Menu Text Transform
    $wp_customize->add_control( 'menu_text_transform', array(
        'label'    => __( 'Menu Text Transform', 'architecture-construction' ),
        'section'  => 'architecture_construction_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            'none'       => __( 'None', 'architecture-construction' ),
            'capitalize' => __( 'Capitalize', 'architecture-construction' ),
            'uppercase'  => __( 'Uppercase', 'architecture-construction' ),
            'lowercase'  => __( 'Lowercase', 'architecture-construction' ),
        ),
    ) );

    $wp_customize->add_setting('architecture_construction_menus_style',array(
        'default' => '',
        'sanitize_callback' => 'architecture_construction_sanitize_choices'
	));
	$wp_customize->add_control('architecture_construction_menus_style',array(
        'type' => 'select',
		'label' => __('Menu Hover Style','architecture-construction'),
		'section' => 'architecture_construction_header_section_settings',
		'choices' => array(
         'None' => __('None','architecture-construction'),
         'Zoom In' => __('Zoom In','architecture-construction'),
      ),
	));

    /** Header Section Settings End */

    /** Social Section Settings */
    $wp_customize->add_section(
        'architecture_construction_social_section_settings',
        array(
            'title' => esc_html__( 'Social Media Section Settings', 'architecture-construction' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'architecture_construction_home_page_settings',
        )
    );

    /** Social Section control */
    $wp_customize->add_setting( 
        'architecture_construction_social_icon_setting', 
        array(
            'default' => true ,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_social_icon_setting',
        array(
            'label'       => __( 'Show Social Icon', 'architecture-construction' ),
            'section'     => 'architecture_construction_social_section_settings',
            'type'        => 'checkbox',
        )
    );

    /**  Social Link 1 */
    $wp_customize->add_setting(
        'architecture_construction_social_link_1',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architecture_construction_social_link_1',
        array(
            'label' => esc_html__( 'Add Facebook Link', 'architecture-construction' ),
            'section' => 'architecture_construction_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 2 */
    $wp_customize->add_setting(
        'architecture_construction_social_link_2',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architecture_construction_social_link_2',
        array(
            'label' => esc_html__( 'Add Twitter Link', 'architecture-construction' ),
            'section' => 'architecture_construction_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 3 */
    $wp_customize->add_setting(
        'architecture_construction_social_link_3',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architecture_construction_social_link_3',
        array(
            'label' => esc_html__( 'Add Instagram Link', 'architecture-construction' ),
            'section' => 'architecture_construction_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 4 */
    $wp_customize->add_setting(
        'architecture_construction_social_link_4',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architecture_construction_social_link_4',
        array(
            'label' => esc_html__( 'Add Pintrest Link', 'architecture-construction' ),
            'section' => 'architecture_construction_social_section_settings',
            'type' => 'url',
        )
    );

    /** Social Section Settings End */

    /** Home Page Settings */
    $wp_customize->add_panel( 
        'architecture_construction_home_page_settings',
         array(
            'priority' => 9,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Home Page Settings', 'architecture-construction' ),
            'description' => esc_html__( 'Customize Home Page Settings', 'architecture-construction' ),
        ) 
    );

    /** Slider Section Settings */
    $wp_customize->add_section(
        'architecture_construction_slider_section_settings',
        array(
            'title' => esc_html__( 'Slider Section Settings', 'architecture-construction' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'architecture_construction_home_page_settings',
        )
    );

    /** Slider Section control */
    $wp_customize->add_setting( 
        'architecture_construction_slider_setting', 
        array(
            'default' => false ,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_slider_setting',
        array(
            'label'       => __( 'Show Slider', 'architecture-construction' ),
            'section'     => 'architecture_construction_slider_section_settings',
            'type'        => 'checkbox',
        )
    );
    
    $categories = get_categories();
        $cat_posts = array();
            $i = 0;
            $cat_posts[]='Select';
        foreach($categories as $category){
            if($i==0){
            $default = $category->slug;
            $i++;
        }
        $cat_posts[$category->slug] = $category->name;
    }

    $wp_customize->add_setting(
        'architecture_construction_blog_slide_category',
        array(
            'default'   => 'select',
            'sanitize_callback' => 'architecture_construction_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'architecture_construction_blog_slide_category',
        array(
            'type'    => 'select',
            'choices' => $cat_posts,
            'label' => __('Select Category to display Latest Post','architecture-construction'),
            'section' => 'architecture_construction_slider_section_settings',
        )
    );

    /** Slider Section control */
    $wp_customize->add_setting( 
        'architecture_construction_slider_button_setting', 
        array(
            'default' => false ,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_slider_button_setting',
        array(
            'label'       => __( 'Show Slider Button', 'architecture-construction' ),
            'section'     => 'architecture_construction_slider_section_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('slider_text_alignment', array(
        'default'           => 'right',
        'transport'         => 'refresh',
        'sanitize_callback' => 'architecture_construction_sanitize_text_alignment',
    ));

    // Add Text Alignment Control
    $wp_customize->add_control('slider_text_alignment_control', array(
        'label'     => __('Slider Text Alignment', 'architecture-construction'),
        'section'   => 'architecture_construction_slider_section_settings', 
        'settings'  => 'slider_text_alignment',
        'type'      => 'radio',
        'choices'   => array(
            'left'    => __('Left', 'architecture-construction'),
            'center'  => __('Center', 'architecture-construction'),
            'right'   => __('Right', 'architecture-construction'),
        ),
    ));


    /** About Section Settings */
    
    $wp_customize->add_section( 'architecture_construction_section_featured_about',
        array(
        'title'      => __( 'About Us Section', 'architecture-construction' ),
        'priority'   => 110,
        'capability' => 'edit_theme_options',
        'panel'      => 'architecture_construction_home_page_settings',
        )
    );

    /** About Section control */
    $wp_customize->add_setting( 
        'architecture_construction_about_setting', 
        array(
            'default' => false ,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_about_setting',
        array(
            'label'       => __( 'Show About', 'architecture-construction' ),
            'section'     => 'architecture_construction_section_featured_about',
            'type'        => 'checkbox',
        )
    );

    // Section Text
    $wp_customize->add_setting('architecture_construction_featured_mission_section_text', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('architecture_construction_featured_mission_section_text', 
        array(
        'label'       => __('Section Text', 'architecture-construction'),
        'section'     => 'architecture_construction_section_featured_about',   
        'settings'    => 'architecture_construction_featured_mission_section_text',
        'type'        => 'text'
        )
    );

    // Section Title
    $wp_customize->add_setting('architecture_construction_featured_mission_section_title', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('architecture_construction_featured_mission_section_title', 
        array(
        'label'       => __('Section Title', 'architecture-construction'),
        'section'     => 'architecture_construction_section_featured_about',   
        'settings'    => 'architecture_construction_featured_mission_section_title',
        'type'        => 'text'
        )
    );

    // Items
    $wp_customize->add_setting('architecture_construction_number_of_featured_mission_items', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'architecture_construction_sanitize_number_range'
        )
    );

    $wp_customize->add_control('architecture_construction_number_of_featured_mission_items', 
        array(
        'label'       => __('Items (Max: 5)', 'architecture-construction'),
        'section'     => 'architecture_construction_section_featured_about',   
        'settings'    => 'architecture_construction_number_of_featured_mission_items',
        'type'        => 'number',
        'input_attrs' => array(
                'min'   => 1,
                'max'   => 5,
                'step'  => 1,
            ),
        )
    );

    $architecture_construction_number_of_featured_mission_items = get_theme_mod( 'architecture_construction_number_of_featured_mission_items' );

    for( $i=1; $i<=$architecture_construction_number_of_featured_mission_items; $i++ ) {

        // Section Tab
        $wp_customize->add_setting('architecture_construction_featured_mission_section_tab_'.$i, 
            array(  
            'type'              => 'theme_mod',
            'capability'        => 'edit_theme_options',
            'sanitize_callback' => 'sanitize_text_field'
            )
        );

        $wp_customize->add_control('architecture_construction_featured_mission_section_tab_'.$i, 
            array(
            'label'       => __('Tab #', 'architecture-construction').$i,
            'section'     => 'architecture_construction_section_featured_about',
            'settings'    => 'architecture_construction_featured_mission_section_tab_'.$i,
            'type'        => 'text'
            )
        );

        // Section Tab Icon
        $wp_customize->add_setting('architecture_construction_featured_mission_section_tab_icon_'.$i, 
            array(  
            'type'              => 'theme_mod',
            'capability'        => 'edit_theme_options',    
            'sanitize_callback' => 'sanitize_text_field'
            )
        );

        $wp_customize->add_control('architecture_construction_featured_mission_section_tab_icon_'.$i, 
            array(
            'label'       => __('Tab Icon #', 'architecture-construction').$i,
            'section'     => 'architecture_construction_section_featured_about',
            'settings'    => 'architecture_construction_featured_mission_section_tab_icon_'.$i,
            'type'        => 'text'
            )
        );

        // Post
        $wp_customize->add_setting('architecture_construction_featured_mission_post_'.$i, 
            array(
            'type'              => 'theme_mod',
            'capability'        => 'edit_theme_options',
            'sanitize_callback' => 'architecture_construction_dropdown_pages'
            )
        );

        $wp_customize->add_control('architecture_construction_featured_mission_post_'.$i, 
            array(
            'label'       => __('Page #', 'architecture-construction').$i,
            'section'     => 'architecture_construction_section_featured_about',   
            'settings'    => 'architecture_construction_featured_mission_post_'.$i,
            'type'        => 'dropdown-pages',
            )
        );
    }
    
   

    // Setting for Work Tab Title
    $wp_customize->add_setting('architecture_construction_work_tab_title', array(
        'default'           => __('How It Works', 'architecture-construction'),
        'sanitize_callback' => 'sanitize_text_field',
    ));

    $wp_customize->add_control('architecture_construction_work_tab_title', array(
        'label'    => __('Work Tab Title', 'architecture-construction'),
        'section'  => 'architecture_construction_section_featured_about',
        'settings' => 'architecture_construction_work_tab_title',
        'type'     => 'text',
    ));

    // Setting for Work Tab Steps
    for ($i = 1; $i <= 3; $i++) {
    $wp_customize->add_setting('architecture_construction_work_tab_step_' . $i, array(
        'default'           => '',
        'sanitize_callback' => 'sanitize_text_field',
    ));

    $wp_customize->add_control('architecture_construction_work_tab_step_' . $i, array(
        'label'    => sprintf(__('Step %d', 'architecture-construction'), $i),
        'section'  => 'architecture_construction_section_featured_about',
        'settings' => 'architecture_construction_work_tab_step_' . $i,
        'type'     => 'text',
    ));
}



add_action('customize_register', 'architecture_construction_customize_register');
    /** Home Page Settings Ends */
    
    /** Footer Section */
    $wp_customize->add_section(
        'architecture_construction_footer_section',
        array(
            'title' => __( 'Footer Settings', 'architecture-construction' ),
            'priority' => 70,
            'panel' => 'architecture_construction_home_page_settings',
        )
    );

    /** Copyright Text */
    $wp_customize->add_setting(
        'architecture_construction_footer_copyright_text',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
        )
    );
    
    $wp_customize->add_control(
        'architecture_construction_footer_copyright_text',
        array(
            'label' => __( 'Copyright Info', 'architecture-construction' ),
            'section' => 'architecture_construction_footer_section',
            'type' => 'text',
        )
    );

    $wp_customize->add_setting('footer_background_image',
        array(
        'default' => '',
        'capability' => 'edit_theme_options',
        'sanitize_callback' => 'absint',
        )
    );

    /* Footer Background Color*/
    $wp_customize->add_setting(
        'footer_background_color',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'footer_background_color',
            array(
                'label' => __('Footer Widget Area Background Color', 'architecture-construction'),
                'section' => 'architecture_construction_footer_section',
                'type' => 'color',
            )
        )
    );

    $wp_customize->add_control(
         new WP_Customize_Cropped_Image_Control($wp_customize, 'footer_background_image',
            array(
                'label' => esc_html__('Footer Background Image', 'architecture-construction'),
                'description' => sprintf(esc_html__('Recommended Size %1$s px X %2$s px', 'architecture-construction'), 1024, 800),
                'section' => 'architecture_construction_footer_section',
                'width' => 1024,
                'height' => 800,
                'flex_width' => true,
                'flex_height' => true,
            )
        )
    );

    /** Footer Background Image Attachment */
    $wp_customize->add_setting('architecture_construction_background_attatchment', array(
        'default'           => 'scroll',
        'sanitize_callback' => 'architecture_construction_sanitize_choices',
    ));

    $wp_customize->add_control('architecture_construction_background_attatchment', array(
        'label'    => __('Footer Background Attachment', 'architecture-construction'),
        'section'  => 'architecture_construction_footer_section',
        'settings' => 'architecture_construction_background_attatchment',
        'type'     => 'select',
        'choices'  => array(
            'fixed' => __('fixed','architecture-construction'),
            'scroll' => __('scroll','architecture-construction'),
        ),
    ));

    /** Scroll To Top control */
    $wp_customize->add_setting( 
        'architecture_construction_footer_scroll_to_top', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architecture_construction_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architecture_construction_footer_scroll_to_top',
        array(
            'label'       => __( 'Show / Hide Scroll To Top', 'architecture-construction' ),
            'section'     => 'architecture_construction_footer_section',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('architecture_construction_scroll_icon',array(
        'default'   => 'fas fa-arrow-up',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Architecture_Construction_Changeable_Icon(
        $wp_customize,'architecture_construction_scroll_icon',array(
        'label' => __('Scroll Icon','architecture-construction'),
        'transport' => 'refresh',
        'section'   => 'architecture_construction_footer_section',
        'type'      => 'icon'
    )));

    $wp_customize->add_setting('architecture_construction_scroll_top_alignment',array(
        'default' => 'right-align',
        'sanitize_callback' => 'architecture_construction_sanitize_scroll_top_alignment'
    ));
    $wp_customize->add_control('architecture_construction_scroll_top_alignment',array(
        'type' => 'select',
        'label' => __('Scroll Top Alignment','architecture-construction'),
        'section' => 'architecture_construction_footer_section',
        'choices' => array(
            'right-align' => __('Right Alignment','architecture-construction'),
            'center-align' => __('Center Alignment','architecture-construction'),
            'left-align' => __('Left Alignment','architecture-construction'),
        ),
    ) );

    /** Scroll to top button shape */
    $wp_customize->add_setting('architecture_construction_scroll_to_top_radius', array(
        'default'           => 'curved-box',
        'sanitize_callback' => 'architecture_construction_sanitize_choices',
    ));

    $wp_customize->add_control('architecture_construction_scroll_to_top_radius', array(
        'label'    => __('Scroll Top Button Shape', 'architecture-construction'),
        'section'  => 'architecture_construction_footer_section',
        'settings' => 'architecture_construction_scroll_to_top_radius',
        'type'     => 'select',
        'choices'  => array(
            'box'        => __( 'Box', 'architecture-construction' ),
            'curved-box' => __( 'Curved Box', 'architecture-construction' ),
            'circle'     => __( 'Circle', 'architecture-construction' ),
        ),
    ));

    // 404 PAGE SETTINGS
    $wp_customize->add_section(
        'architecture_construction_404_section',
        array(
            'title' => __( '404 Page Settings', 'architecture-construction' ),
            'priority' => 70,
            'panel' => 'architecture_construction_general_settings',
        )
    );


    $wp_customize->add_setting('404_page_image', array(
        'default' => '',
        'transport' => 'refresh',
        'sanitize_callback' => 'esc_url_raw',
    ));

    $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, '404_page_image', array(
        'label' => __('404 Page Image', 'architecture-construction'),
        'section' => 'architecture_construction_404_section',
        'settings' => '404_page_image',
    )));

    $wp_customize->add_setting('404_pagefirst_header', array(
        'default' => __('404', 'architecture-construction'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_pagefirst_header', array(
        'type' => 'text',
        'label' => __('Heading', 'architecture-construction'),
        'section' => 'architecture_construction_404_section',
    ));

    // Setting for 404 page header
    $wp_customize->add_setting('404_page_header', array(
        'default' => __('Sorry, that page can\'t be found!', 'architecture-construction'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_page_header', array(
        'type' => 'text',
        'label' => __('Heading', 'architecture-construction'),
        'section' => 'architecture_construction_404_section',
    ));
    /** Footer control END */
}
add_action( 'customize_register', 'architecture_construction_customize_register' );
endif;

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function architecture_construction_customize_preview_js() {
    // Use minified libraries if SCRIPT_DEBUG is false
    $architecture_construction_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
    $architecture_construction_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';
	wp_enqueue_script( 'architecture_construction_customizer', get_template_directory_uri() . '/js' . $architecture_construction_build . '/customizer' . $architecture_construction_suffix . '.js', array( 'customize-preview' ), '20130508', true );
}
add_action( 'customize_preview_init', 'architecture_construction_customize_preview_js' );